SystemOrganization addCategory: #ParcialMarcComino!

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'Nsize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialMarcComino'!

!Matriu class methodsFor: 'instance creation' stamp: 'MarcComino 11/7/2012 17:16'!
new: unNombre
	^ (super new: (unNombre*unNombre)) initialize: unNombre.
! !

!Matriu methodsFor: 'accessing' stamp: 'MarcComino 11/7/2012 17:22'!
at: unParell
	^super at: (Nsize*(unParell first - 1)+(unParell second)).! !

!Matriu methodsFor: 'accessing' stamp: 'MarcComino 11/7/2012 17:22'!
at: unParell put: unNombre
	^super at: (Nsize*(unParell first -1)+(unParell second)) put: unNombre.! !

!Matriu methodsFor: 'initialize-release' stamp: 'MarcComino 11/7/2012 17:30'!
initialize: unNombre 
	Nsize := unNombre.
	firstIndex := 1.
	lastIndex := (unNombre*unNombre).! !

!Matriu methodsFor: 'accessing' stamp: 'MarcComino 10/31/2012 17:19'!
nsize
	^ Nsize! !

!Matriu methodsFor: 'accessing' stamp: 'MarcComino 10/31/2012 17:19'!
nsize: anObject
	Nsize := anObject! !

Object subclass: #Pair
	instanceVariableNames: 'first second'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialMarcComino'!

!Pair class methodsFor: 'instance variables' stamp: 'MarcComino 10/31/2012 17:14'!
first: First second: Second
	^ self new first: First; second: Second.! !

!Pair methodsFor: 'accessing' stamp: 'MarcComino 10/31/2012 17:12'!
first
	^ first! !

!Pair methodsFor: 'accessing' stamp: 'MarcComino 10/31/2012 17:12'!
first: anObject
	first := anObject! !

!Pair methodsFor: 'accessing' stamp: 'MarcComino 10/31/2012 17:13'!
second
	^ second! !

!Pair methodsFor: 'accessing' stamp: 'MarcComino 10/31/2012 17:13'!
second: anObject
	second := anObject! !

Object subclass: #Preguntes2to6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialMarcComino'!

!Preguntes2to6 methodsFor: 'Pregunta-6' stamp: 'MarcComino 11/7/2012 21:34'!
haltIf
	"public void haltIf(String methodName) {
		StackTraceElement[] context = new Throwable().getStackTrace();
		for (int i = 0; i < context.length; ++i) {
			if (context[i].getMethodName().equals(methodName)) System.exit(0);
		}
	}"
	! !

!Preguntes2to6 methodsFor: 'Pregunta-5' stamp: 'MarcComino 11/7/2012 21:36'!
haltIf: unSelector
	| context |
	context := thisContext.
	[context sender isNil] whileFalse: [context := context sender.
									    (context selector = unSelector) ifTrue: [ Halt signal ] ].! !

!Preguntes2to6 methodsFor: 'Pregunta-5' stamp: 'MarcComino 11/8/2012 17:26'!
haltIfRecursive: unSelector
	self haltIfRecursive: unSelector context: thisContext.
! !

!Preguntes2to6 methodsFor: 'Pregunta-5' stamp: 'MarcComino 11/8/2012 17:35'!
haltIfRecursive: unSelector context: unContext
	[unContext sender isNil] ifFalse: [ (unContext selector = unSelector) ifTrue: [ Halt signal ]
																		   ifFalse: [ self haltIfRecursive: unSelector context: unContext ]].! !

!Preguntes2to6 methodsFor: 'Pregunta-2' stamp: 'MarcComino 11/9/2012 22:55'!
pregunta2
"La introspecci s la capacitat d'un programa d'observar el seu propi estat (a travs de metaobjectes, que contenen metadades)  i de raonar sobre aquest, en temps d'execuci."
"La intercessi es la capacitat d'un programa de modificar el seu propi estat (o sigui, de canviar la metainformaci), en temps d'execuci."
"La reificaci s el procs mitjanant el qual, es tradueix l'estat del programa en dade manipulables."
"Tant Smalltalk com Java tenen limitacions pel que fa a la reflexi. En el cas de Smalltalk hi podem fer tant introspecci com intercessi (amb la limitaci que no podem reificar l'enviament de missatges) i podem manipular el propi sistema ja que podem accedir al codi de tot."
"Per Java les limitacions sn molt ms destacables ja que, podriem dir, que gaireb no podem fer intercessi o, com a mnim, no de manera directa. Els nics mecanismes que podem utilitzar sn els Proxys (que ens permenten fer intercepci de missatges) i la generaci dinmica de codi, conjuntament amb crrega dinmica de classes, que en permet afegir codi al nostre sistema en temps d'execuci. Un altre exemple de limitaci s que no podem modificar ni consultar directament la pila d'execuci, per fer-ho hem d'utilitzar una trampa mitjanant objectes Throwable."! !

!Preguntes2to6 methodsFor: 'Pregunta-3' stamp: 'MarcComino 11/9/2012 22:49'!
pregunta3
"Tant Java com Smalltalk sn llenguatges orientats a objectes per tant, tericament, tot hauria de ser un objecte. Aix explica que, coses com les classes, haurien de ser objectes. Les metaclasses sn la resposta a la pregunta, de qui sn instncia les classes."
"En Smalltalk, trobem una jerarquia de metaclasses parallela a la jerarquia de classes. Cada metaclasse t una nica intncia (la classe), i tota metaclasse s, alhora, instncia de Metaclass. Metaclass, al se una classe, s instncia de la seva metaclasse, Metclass class, i, aquesta, com tota metaclasse, s intncia de Metaclass (aix defineix una circularitat que s inofensiva)."
"En Java hi ha una nica metaclasse, anomenada Class, de la que tota classe s instncia i, en particular, Class s instncia de si mateixa (trobem una circularitat semblant a la de Smalltalk per ms simple). Per tant, tenim un nivell d'abstracci menys que a Smalltalk, cosa que implica que a Java totes les classes tindran una estructura i comportament similar (voler modificar una, implicaria modificar-les totes)."! !

!Preguntes2to6 methodsFor: 'Pregunta-4' stamp: 'MarcComino 11/9/2012 22:32'!
pregunta4

"Els elements de la pila d'execuci que reifica thisContext, son tot instncies de la classe MethodContext. En un passat tamb existia la classe BlockContext, per que avui en dia est deprecated.
Com hem dit, thisContext retorna un objecte de la classe MethodContext. Un mtode m retornar una expressi al sender de thisContext. En canvi, un bloc captura el seu context en el moment de la seva creaci, per tant, es retornar ^expressi al sender del thisContext del mtode que va crear el bloc." ! !
